#!/bin/sh
#
# GSS 06:07:2000
#
# Misc maintainence stuff not handled by autoconf etc (AFAIK)
#

if [ $# -eq 1 ]
then
    MODE=$1
else
    MODE="usage"
fi

case $MODE in
    clean)
        echo Making clean for cvs
        ./configure
        make maintainer-clean
    ;;
    ready)
        echo Preparing package for distribution
        aclocal
        autoconf
        autoheader
        automake -i -a -v
    ;;
    tags)
        ctags src/*/*.[ch]
    ;;
    fixme)
        echo Displaying FIXME comments
        grep -l FIXME src/*/*.[ch] | while read SRCPATH
        do
            echo ========================
            echo From $SRCPATH :
            echo ----
            gawk '/\/[*] FIXME:/{t=1}    \
                 {if(t==1)print NR":"$0} \
                 /[*]\//{if(t==1){t=0;print "--"}}' $SRCPATH
            echo
        done
    ;;
    *)
        echo -n "usage : maintain.sh "
        echo "[ clean | ready | tags | fixme ]"
        exit 1;
    ;;
esac

