/****************************************************************\
*                                                                *
*  Plugin: write code, compile it as a plugin, link it back in   *
*                                                                *
*  Guy St.C. Slater..   mailto:guy@ebi.ac.uk                     *
*  Copyright (C) 2000,2001,2002,2003.  All Rights Reserved.      *
*                                                                *
*  This source code is distributed under the terms of the        *
*  GNU Lesser General Public License. See the file COPYING       *
*  or http://www.fsf.org/copyleft/lesser.html for details        *
*                                                                *
*  If you use this code, please keep this notice intact.         *
*                                                                *
\****************************************************************/

#include <glib.h>
#include "plugin.h"

typedef gint (*PluginTestFunc) (void);

int main(void){
    register gchar *module = "testmodule";
    register Plugin *p = Plugin_create(NULL, module);
    register PluginTestFunc ptf;
    Plugin_printf(p, "%s\n\n%s\n",
          "#include <stdio.h>",
          "int test_func(){");
    Plugin_indent(p, 1);
    Plugin_printf(p, "%s\n%s\n%s\n%s",
          "register int total = 1+2+3+4;",
          "printf(\"testing C4 plugin [%d]\\n\", total);",
          "return total;",
          "}");
    Plugin_indent(p, -1);
    Plugin_compile(p, NULL, NULL);
    Plugin_unload(p);
    p = Plugin_load(NULL, module);
    if(!p)
        g_error("Could not reload plugin");
    ptf = (PluginTestFunc)Plugin_lookup(p, "test_func");
    g_assert(ptf() == 10);
    Plugin_destroy(p);
    return 0;
    }

