/****************************************************************\
*                                                                *
*  UTR alignment model                                           *
*                                                                *
*  Guy St.C. Slater..   mailto:guy@ebi.ac.uk                     *
*  Copyright (C) 2000-2005.  All Rights Reserved.                *
*                                                                *
*  This source code is distributed under the terms of the        *
*  GNU Lesser General Public License. See the file COPYING       *
*  or http://www.fsf.org/copyleft/lesser.html for details        *
*                                                                *
*  If you use this code, please keep this notice intact.         *
*                                                                *
\****************************************************************/

#ifndef INCLUDED_UTR_H
#define INCLUDED_UTR_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "c4.h"
#include "sequence.h"
#include "affine.h"
#include "coding2genome.h"

typedef struct {
    Coding2Genome_Data c2gd;
} UTR_Data;

#define UTR_Data_get_submat(utrd) \
         Coding2Genome_Data_get_submat(&((utrd)->c2gd))
#define UTR_Data_get_translate(utrd) \
         Coding2Genome_Data_get_translate(&((utrd)->c2gd))
#define UTR_Data_get_Intron_Data(utrd) \
         Coding2Genome_Data_get_Intron_Data(&((g2gd)->c2gd))

/**/

UTR_Data *UTR_Data_create(Sequence *query, Sequence *target);
void UTR_Data_destroy(UTR_Data *utr_data);

/**/

C4_Model *UTR_create(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* INCLUDED_UTR_H */

