/****************************************************************\
*                                                                *
*  Efficient single-linked list routines.                        *
*                                                                *
*  Guy St.C. Slater..   mailto:guy@ebi.ac.uk                     *
*  Copyright (C) 2000-2008.  All Rights Reserved.                *
*                                                                *
*  This source code is distributed under the terms of the        *
*  GNU General Public License, version 3. See the file COPYING   *
*  or http://www.gnu.org/licenses/gpl.txt for details            *
*                                                                *
*  If you use this code, please keep this notice intact.         *
*                                                                *
\****************************************************************/

#include <string.h> /* For strcmp() */
#include "dlist.h"

typedef struct {
    gchar *crib[9];
     gint  count;
} DList_TestInfo;

static gboolean dlist_test_traverse(gpointer data, gpointer user_data){
    register gchar *word = data;
    DList_TestInfo *dti = user_data;
    g_message("Word [%5s] crib[%5s] count[%d]",
              word, dti->crib[dti->count], dti->count);
    g_assert(!strcmp(word, dti->crib[dti->count]));
    dti->count++;
    return FALSE;
    }

int main(void){
    register DListSet *dlist_set = DListSet_create();
    register DList *a = DList_create(dlist_set),
                   *b = DList_create(dlist_set), *c;
    DList_TestInfo dti = { {"The", "quick", "brown", "fox",
                            "jumps", "over", "a", "lazy", "dog"},
                          0};
    register DListNode *node;
    g_message("check [%d][%d]", DList_isempty(a), DList_isempty(b));
    DList_queue(a, "jumps");
    /* DList_stack(a, "fox"); */
    DList_queue(a, "over");
    node = DList_stack(a, "brown");
    DList_queue(a, "a");
    DList_queue(a, "lazy");
    DList_queue(a, "dog");
    DList_stack(b, "quick");
    DList_stack(b, "The");
    g_message("prej");
    c = DList_join(b, a);
    DList_destroy(a);
    DList_insert_after(b, node, "fox");
    DList_traverse(c, dlist_test_traverse, &dti);
    DList_destroy(c);
    DListSet_destroy(dlist_set);
    return 0;
    }

